unit An8255CardFrame;

interface

uses 
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, An8255Frame, StdCtrls;

type
  TOne8255CardFrame = class(TFrame)
    ACardPanel: TPanel;
    CardInfoPanel: TPanel;
    Cards8255Panel: TPanel;
    ACardDescriptionLabel: TLabel;
  private
    { Private declarations }
  public
    DeviceID: LongWord;
    Num8255: LongWord;
    Name: String;
    Note: String;
    Group: Array of TOne8255Frame;
    function Show8255Frame(C, G, X, Y:integer): TOne8255Frame;
    function BuildCardFrames( C, X, Y:integer):Boolean;
    { Public declarations }
  end;

implementation

uses pcidio8255Unit1;

{$R *.DFM}

{ TOne8255CardFrame }

function TOne8255CardFrame.Show8255Frame(C, G, X, Y:integer): TOne8255Frame;
var
  Frame: TOne8255Frame;

begin
  Num8255 := G;
  Frame := FindComponent ('One8255Frame' + IntToHex(C,2) + IntToHex(G,4)) as TOne8255Frame;
  if not Assigned (Frame) then
  begin
    Frame := TOne8255Frame.Create (Form1);
    Frame.Parent := Cards8255Panel;
    Frame.Visible := True;
    Frame.Left := X;
    Frame.Top := Y;
    Frame.Tag := G;
    Frame.lGroupCaption.Caption := 'Group #' + IntToStr(G);
    Frame.Name := 'One8255Frame' + IntToHex(C,2) + IntToHex(G,4);
  end;
  Result := Frame;
end;

function TOne8255CardFrame.BuildCardFrames( C, X, Y: integer ): Boolean;
  var
    G:Integer;
    H:Integer;
begin
  try
    SetLength( Group, Num8255 );
    for G := 0 to high(Group) do
    begin
      Group[G] := Show8255Frame( C, G, X, 0);
      Group[G].An8255.CardNum := C;
      Group[G].An8255.GroupNum := G;
      X := X + Group[G].Width + MARGIN8255;// 4 is the "between connectors (8255s) margin")
    end;
    Width := X + 2*(bevelwidth+bevelwidth+borderwidth+MARGIN8255);//MARGIN8255*2;
    Height := CardInfoPanel.Height + Group[0].Height + 2*(bevelwidth+bevelwidth+borderwidth+MARGIN8255);
    ACardDescriptionLabel.Caption := Name + #13 + Note + #13 + '(CardNum is ' + IntToStr(C) + ')';
    Result := True;
  except
    Result := False;
  end;
end;

Begin
  RegisterClass(TOne8255CardFrame);
end.
