unit An8255Frame;

interface

uses 
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Buttons;

type

  TDIO8255Data = class(TObject)
  private
    _CardNum: Byte;
    _GroupNum: Byte;
    _Data: Longword;
    _Mode: Byte;
    procedure SetByte(Index: Integer; Value: Byte);
    function GetByte(Index: Integer):Byte;
    procedure SetCHi(Value: Byte);
    procedure SetClo(Value: Byte);
    function GetCHi:Byte;
    function GetCLo:Byte;
    function GetMode: Byte;
    procedure SetMode(const Value: Byte);
  public
    constructor create;
    property Data: Longword read _Data write _Data;
    property All: Longword read _Data write _Data;
    property A: Byte index 0 read GetByte write SetByte;
    property B: Byte index 1 read GetByte write SetByte;
    property C: Byte index 2 read GetByte write SetByte;
    property CHi: Byte read GetCHi write SetCHi;
    property CLo: Byte read GetCLo write SetCLo;
    property Mode: Byte read GetMode write SetMode;
    property CardNum: Byte read _CardNum write _CardNum;  // extend to handle undetected cardnums
    property GroupNum: Byte read _GroupNum write _GroupNum; //extend to restrict to groups 0-5?

  end; // TDIO8255Data


  TDIO8255 = class(TObject)
    _CardNum: Byte;
    _GroupNum: Byte;
    PortDirection: array[0..4] of Boolean;            // TRUE is OUTPUT
    DIO: TDIO8255Data;
    constructor create;
    destructor destruct;
    function Configure(OutMask: Byte; Data: LongWord): LongWord; overload;
    function Configure: LongWord; overload;

    function SetBit(BitIndex: Longword): Longword;
    function ClrBit(BitIndex: Longword): Longword;                function ClearBit(BitIndex: Longword): Longword;
    function TglBit(BitIndex: Longword): Longword;                function ToggleBit(BitIndex: Longword): Longword;
    function WrtBit(BitIndex: Longword; Bit:Boolean): Longword;   function WriteBit(BitIndex: Longword; Bit:Boolean): Longword;
    function WrtPrt(PortIndex, Value: Byte): Longword;            function WritePort(PortIndex, Value: Byte): Longword;
    function WrtByt(ByteIndex: Longword; Value: Byte): Longword;  function WriteByte(ByteIndex: Longword; Value: Byte): Longword;
    function WrtAll(Value:LongWord): Longword;                    function WriteAll(Value:LongWord): Longword;

    function ReadBit(BitIndex: Longword): Boolean;
    function ReadPrt(PortIndex: Byte): Byte;                      function ReadPort(PortIndex: Byte): Byte;
    function ReadByt(ByteIndex: Longword): Byte;                  function ReadByte(ByteIndex: Longword): Byte;
    function ReadAll: Longword;

    function doUpdate: Longword;
    function doReading: Longword;
    procedure SetCardNum(const Value: Byte);
    procedure SetGroupNum(const Value: Byte);
    property CardNum: Byte read _CardNum write SetCardNum;  // extend to handle undetected cardnums
    property GroupNum: Byte read _GroupNum write SetGroupNum; //extend to restrict to groups 0-5?
  private
    function Mode(OutMask: Byte): Longword;
  end; // TDIO8255Info

  TOne8255Frame = class(TFrame)
    Label21: TLabel;
    Label22: TLabel;
    Label23: TLabel;
    Panel2: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    PaintBox25: TPaintBox;
    PaintBox26: TPaintBox;
    PaintBox27: TPaintBox;
    PaintBox28: TPaintBox;
    PaintBox29: TPaintBox;
    PaintBox30: TPaintBox;
    PaintBox31: TPaintBox;
    PaintBox32: TPaintBox;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    Button7: TButton;
    Button8: TButton;
    Button9: TButton;
    Button10: TButton;
    Button11: TButton;
    Button12: TButton;
    Button13: TButton;
    Button14: TButton;
    Button15: TButton;
    Button16: TButton;
    Button41: TSpeedButton;
    Button42: TSpeedButton;
    Panel3: TPanel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    b08: TPaintBox;
    b09: TPaintBox;
    b10: TPaintBox;
    b11: TPaintBox;
    b12: TPaintBox;
    b13: TPaintBox;
    b14: TPaintBox;
    b15: TPaintBox;
    Button17: TButton;
    Button18: TButton;
    Button19: TButton;
    Button20: TButton;
    Button21: TButton;
    Button22: TButton;
    Button23: TButton;
    Button24: TButton;
    Button25: TButton;
    Button26: TButton;
    Button27: TButton;
    Button28: TButton;
    Button29: TButton;
    Button30: TButton;
    Button31: TButton;
    Button32: TButton;
    Button43: TSpeedButton;
    Button44: TSpeedButton;
    Panel4: TPanel;
    Label25: TLabel;
    Label26: TLabel;
    Label27: TLabel;
    Label28: TLabel;
    b16: TPaintBox;
    b17: TPaintBox;
    b18: TPaintBox;
    b19: TPaintBox;
    Button49: TButton;
    Button50: TButton;
    Button51: TButton;
    Button52: TButton;
    Button53: TButton;
    Button54: TButton;
    Button55: TButton;
    Button56: TButton;
    Button45: TSpeedButton;
    Button46: TSpeedButton;
    Panel5: TPanel;
    Label17: TLabel;
    Label18: TLabel;
    Label19: TLabel;
    Label20: TLabel;
    b20: TPaintBox;
    b21: TPaintBox;
    b22: TPaintBox;
    b23: TPaintBox;
    Button33: TButton;
    Button34: TButton;
    Button35: TButton;
    Button36: TButton;
    Button37: TButton;
    Button38: TButton;
    Button39: TButton;
    Button40: TButton;
    Button47: TSpeedButton;
    Button48: TSpeedButton;
    lGroupCaption: TLabel;
    Label29: TLabel;
    Label24: TLabel;
    Label30: TLabel;
    Label31: TLabel;
    constructor Create(AOwner:TComponent); override;
    destructor Destroy; override;
    procedure bitPaint(Sender: TObject);
    procedure bitPaintOn(Sender: TPaintBox);
    procedure bitPaintOff(Sender: TPaintBox);
    procedure bitPaintCore(Sender: TPaintBox; text:String);
    procedure DoBitPaint(Sender: TPaintBox);
    procedure OutputButtonClick(Sender: TObject);
    procedure InputButtonClick(Sender: TObject);
    procedure SetBitHigh(Sender: TObject);
    procedure SetBitLow(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    An8255:TDIO8255;
    procedure doUpdate;
  end;

implementation
{$R *.DFM}
uses AIOWDM;
{ TDIO8255Info }

function TDIO8255.Mode(OutMask: Byte): Longword;
  var
    bmA, bmB, bmCLo, bmCHi: Byte;
begin
  if (OutMask and 1) = 0 then bmA := $10 else bmA := 0;
  if (OutMask and 2) = 0 then bmB := $02 else bmB := 0;
  if (OutMask and 4) = 0 then bmCLo := $01 else bmCLo := 0;
  if (OutMask and 8) = 0 then bmCHi := $08 else bmCHi := 0;
  Result := RelOutPortB(CardNum, GroupNum *4 +3, bmA or bmB or bmCLo or bmCHi or $80);
end;

function TDIO8255.Configure(OutMask: Byte; Data: LongWord): LongWord;
begin
  Mode(OutMask);
  WrtAll(DIO.Data);
  Result := 0;
end;

function TDIO8255.Configure: LongWord;
  var
    OutMask:Byte;
begin
  OutMask := (ord(PortDirection[0]) * 1) or (ord(PortDirection[1]) * $02) or (ord(PortDirection[2]) * $04) or (ord(PortDirection[3]) * $08);
  Configure(OutMask, DIO.Data);
end;

function TDIO8255.ClearBit(BitIndex: Longword): Longword;
begin
  ClrBit(BitIndex);
  Result := 0;
end;

function TDIO8255.ClrBit(BitIndex: Longword): Longword;
begin
  WrtByt(BitIndex div 8, ReadByt(BitIndex div 8) and (not(1 shl (BitIndex mod 8))) );
  Result := 0;
end;

function TDIO8255.SetBit(BitIndex: Longword): Longword;
begin
  WrtByt(BitIndex div 8, ReadByt(BitIndex div 8) or (1 shl (BitIndex mod 8)) );
  Result := 0;
end;

function TDIO8255.ReadAll: Longword;
begin
  Result := RelInPortL(CardNum, GroupNum * 4) and $00FFFFFF;
end;

function TDIO8255.ReadBit(BitIndex: Longword): Boolean;
begin
  Result := (RelInPortL(CardNum, GroupNum * 4) and (1 shl BitIndex)) <> 0;
end;

function TDIO8255.ReadByt(ByteIndex: Longword): Byte;
begin
  Result := RelInPortB(CardNum, GroupNum * 4 + ByteIndex mod 4);
end;

function TDIO8255.ReadByte(ByteIndex: Longword): Byte;
begin
  Result := ReadByt(ByteIndex);
end;

function TDIO8255.ReadPort(PortIndex: Byte): Byte;
begin
  Result := ReadPrt(PortIndex);
end;

function TDIO8255.ReadPrt(PortIndex: Byte): Byte;
begin
  if PortIndex mod 4 < 3 then
    Result := RelInPortB(CardNum, GroupNum * 4 + PortIndex mod 4)
  else
    Result := (RelInPortB(CardNum, GroupNum * 4 + 2) shr 4) and $0F;
end;


function TDIO8255.TglBit(BitIndex: Longword): Longword;
begin

  Result := 0;
end;

function TDIO8255.ToggleBit(BitIndex: Longword): Longword;
begin
  result := TglBit(BitIndex);
end;

function TDIO8255.WriteAll(Value: LongWord): Longword;
begin
  Result := WrtAll(Value);
end;

function TDIO8255.WrtAll(Value: LongWord): Longword;
begin
  RelOutPort( CardNum, GroupNum *4, Value and $0000ffff);
  RelOutPortB( CardNum, GroupNum *4 + 2, (Value shr 16) and $000000ff);  // bugger
  Result := 0;
end;

function TDIO8255.WriteBit(BitIndex: Longword; Bit:Boolean): Longword;
begin
  Result := WrtBit(BitIndex, Bit);
end;

function TDIO8255.WrtBit(BitIndex: Longword; Bit:Boolean): Longword;
begin
  if Bit then
    Result := SetBit(BitIndex)
  else
    Result := ClrBit(BitIndex);
end;

function TDIO8255.WriteByte(ByteIndex: Longword; Value: Byte): Longword;
begin
  Result := WrtByt(ByteIndex, Value);
end;

function TDIO8255.WrtByt(ByteIndex: Longword; Value: Byte): Longword;
begin
  Result := RelOutPortB(CardNum, GroupNum *4 + ByteIndex mod 4, Value);
end;

function TDIO8255.WritePort(PortIndex, Value: Byte): Longword;
begin
  Result := WrtPrt(PortIndex, Value);
end;

function TDIO8255.WrtPrt(PortIndex, Value: Byte): Longword;
begin
  Result := 0;
  case PortIndex of
  0: Result := RelOutPortB(CardNum, GroupNum * 4 + PortIndex mod 4, Value );
  1: Result := RelOutPortB(CardNum, GroupNum * 4 + PortIndex mod 4, Value );
  2: Result := RelOutPortB(CardNum, GroupNum * 4 + PortIndex mod 4, ReadByt(2) and $F0 or Value );
  3: Result := RelOutPortB(CardNum, GroupNum * 4 + PortIndex mod 4, ReadByt(2) and $0F or (Value shl 4) );
  end;
end;

{ TDIO8255Data }

constructor TDIO8255Data.create;
begin
  inherited;
  Mode := $80;
end;

function TDIO8255Data.GetByte(Index: Integer): Byte;
begin
  Result := (_Data shr (index * 8)) and $FF;
end;

function TDIO8255Data.GetCHi: Byte;
begin
  Result := (_Data shr (2 * 8)) and $F0;
end;

function TDIO8255Data.GetCLo: Byte;
begin
  Result := (_Data shr (2 * 8)) and $0F;
end;

function TDIO8255Data.GetMode: Byte;
begin
  Result := _Mode;
end;

procedure TDIO8255Data.SetByte(Index: Integer; Value: Byte);
begin
  _Data := _Data and (not ($FF shl (Index * 8))) or (Value shr (Index * 8))
end;

procedure TDIO8255Data.SetCHi(Value: Byte);
begin
  _Data := _Data and $000FFFFF or ((Value and $F0) shr 16);
end;

procedure TDIO8255Data.SetClo(Value: Byte);
begin
  _Data := _Data and $00F0FFFF or ((Value and $0F) shr 16);
end;

function TDIO8255.doReading: Longword;
begin
  DIO.Data := ReadAll;
  Result := 0;
end;

function TDIO8255.doUpdate: Longword;
begin
  Result := WrtAll( DIO.Data );
end;

constructor TDIO8255.create;
  var
    modereg : Byte;
begin
  inherited;
  DIO := TDIO8255Data.Create;
  modereg := RelInportB(CardNum, GroupNum*4 + 3);
  PortDirection[0] := modereg and $10 <> $10;
  PortDirection[1] := modereg and $2 <> $2;
  PortDirection[2] := modereg and $1 <> $1;
  PortDirection[3] := modereg and $8 <> $8;
  Configure;
end;

destructor TDIO8255.destruct;
begin
  FreeAndNil(DIO);
  inherited;
end;

procedure TOne8255Frame.bitPaintCore(Sender: TPaintBox; text:String);
  Var
    x1, y1, x2, y2, x3, y3, cx, cy, tx, ty: Integer;
    ts : TSize;
begin
  y1 := Sender.Canvas.ClipRect.Top    +1;
  x1 := Sender.Canvas.ClipRect.Left   +1;
  x2 := Sender.Canvas.ClipRect.Right  -1;
  y2 := Sender.Canvas.ClipRect.Bottom -1;
  x3 := 8;
  y3 := 8;
  cx := (x2 + x1) div 2;
  cy := (y2 + y1) div 2;
  ts := Sender.Canvas.textextent(text);
  tx := cx - ts.cx div 2 +1;
  ty := cy - ts.cy div 2 -1;
  Sender.Canvas.Pen.Color := clBtnShadow;
  Sender.Canvas.RoundRect( x1, y1, x2, y2, x3, y3 );
  Sender.Canvas.TextOut( tx, ty, text );
end;

procedure TOne8255Frame.bitPaintOn(Sender: TPaintBox);
begin
  Sender.Canvas.Brush.Color := clGreen;
  bitPaintCore(Sender, '1');
end;

procedure TOne8255Frame.bitPaintOff(Sender: TPaintBox);
begin
  Sender.Canvas.Brush.Color := clNone;
  bitPaintCore(Sender, '0');
end;

procedure TOne8255Frame.DoBitPaint(Sender: TPaintBox);
begin
  if An8255 <> nil then
  begin

    if An8255.DIO.Data and (1 shl Sender.Tag) = 0 then
      bitPaintOff(Sender)
    else
      bitPaintOn(Sender);
  end else begin
    bitPaintOff(Sender);
  end;
end;

procedure TOne8255Frame.bitPaint(Sender: TObject);
begin
  DoBitPaint(Sender as TPaintBox);
end;

constructor TOne8255Frame.Create(AOwner:TComponent);
begin
  inherited;
  An8255 := TDIO8255.Create;
end;

destructor TOne8255Frame.Destroy;
begin
  FreeAndNil(An8255);
  inherited;
end;

procedure TOne8255Frame.DoUpdate;
  var
    I, J: integer;
begin
  An8255.doReading;

  For I := 0 to ControlCount-1 do
    if Controls[I] is TPanel then
      with Controls[I] as TPanel do
        For J := 0 to ControlCount-1 do
           if Controls[J] is TPaintBox then
             (Controls[J] as TPaintBox).OnPaint(Controls[J]);                                  // use .OnPaint instead of .Invalidate to reduce/eliminate flicker.

end;

procedure TDIO8255Data.SetMode(const Value: Byte);
begin
  _Mode := Value;
  RelOutPortB(CardNum, GroupNum * 4, _Mode);
end;


procedure TOne8255Frame.OutputButtonClick(Sender: TObject);
begin
   An8255.PortDirection[(Sender as TSpeedButton).tag] := true;
   An8255.Configure;
end;

procedure TOne8255Frame.InputButtonClick(Sender: TObject);
begin
   An8255.PortDirection[(Sender as TSpeedButton).tag] := false;
   An8255.Configure;
end;


procedure TOne8255Frame.SetBitHigh(Sender: TObject);
begin
  with (sender as tbutton) do
    An8255.SetBit(tag);
end;


procedure TOne8255Frame.SetBitLow(Sender: TObject);
begin
  with (sender as tbutton) do
    An8255.ClearBit(tag);
end;

procedure TDIO8255.SetCardNum(const Value: Byte);
begin
  _CardNum := Value;
  DIO.CardNum := Value;
end;

procedure TDIO8255.SetGroupNum(const Value: Byte);
begin
  _GroupNum := Value;
  DIO.GroupNum := Value;
end;

begin
  RegisterClass(TOne8255Frame);
end.
